# Задача 10. Своя функция zip (необязательная)
# В самом конце собеседования вас неожиданно спросили: «Расскажите, что делает функция zip?». В итоге, чтобы произвести
# максимальное впечатление, вы решили не только рассказать про неё, но и написать её аналог. Даны строка и кортеж из
# чисел. Напишите программу, которая создаёт генератор из пар кортежей «символ — число». Затем выведите на экран сам
# генератор и кортежи.
# Пример:
# Строка: abcd
# Кортеж чисел: (10, 20, 30, 40)
# Результат:
# <generator object <genexpr> at 0x00000204A4234048>
# ('a', 10)
# ('b', 20)
# ('c', 30)
# ('d', 40)
# Дополнительно: создайте полный аналог функции zip, то есть сделайте так, чтобы программа работала с любыми
# итерируемыми типами данных.


def analog_zip(a, b):
    return ((a[i_ind], b[i_ind]) for i_ind in range(min(len(a), len(b))))


iter_1 = 'sdg'
iter_2 = [1, 5, 74, 4, 3, 10, 60]

print(zip(iter_1, iter_2))
for i in zip(iter_1, iter_2):
    print(i)

print(analog_zip(iter_1, iter_2))
for i in analog_zip(iter_1, iter_2):
    print(i)

# працює для всього окрім словарів. Пробував і для них прописати, виходить надто громіздке і несуразне, припускаю,
# що для цієї задачі треба використовувати те, що ще не вчили.


